#charset "us-ascii"

#include <adv3.h>
#include <en_us.h>


frog : Actor 'poor ootsy wootsy widdy biddy little cute huggy wuggums twitching injured poor frog/bullfrog' 'injured bullfrog'
	location = froggerRoadway3d

	specialDesc {
		if(roomLocation.ofKind(FroggerRoomSet)) {
			"There is an injured bullfrog here twitching pitifully in an apparent attempt
			to continue on its trek northward. ";
		} else {
			"There is an injured bullfrog here twitching pitifully. ";
		}
	}
		
	desc {
		"The poor little bullfrog! Apparently its legs are broken. That's presumably
		the reason why it keeps twitching so horribly.
		And just look at its big watery eyes!
		It's such a a poor ootsy wootsy widdy biddy little frog!
		It's soooo cute! It's just a little huggy wuggums it is! ";
	}

	// This ensures that it can't be seen from a distance.
    sightSize = small
	
//	showDistantSpecialDesc {}
//	showDistantSpecialDescInContents (pov, cont) {}
//	distantInitDesc = "DISTANT INIT DESC\n"
//	distantDesc = "It's difficult to make out any detail from this distance. "
//	distantSpecialDesc = "DISTANT SPECIAL DESC\n"
//	defaultDistantDesc = "DISTANT DEFAULT DESC\n"
	
	
	posture = lying
	
	dobjFor(Attack) {
		verify() {}
		check() {}
		action() {
			"The frog looks at you with huge watery eyes that are so cute that it is impossible for you
			to even consider doing anything that would hurt it. ";
			exit;
		}
	}
	
	iobjFor(ThrowAt) {
		check() {
			"The frog looks at you with huge watery eyes that are so cute that it is impossible for you
			to even consider doing anything that would hurt it. ";
			exit;
		}
	}
	
	dobjFor(Push) asDobjFor(Attack)
	dobjFor(Pull) asDobjFor(Attack)
	
	
	dobjFor(Kiss) {
		verify() {}
		check() {}
		action() {
//			"Yuck! You're into both necrophilia AND bestiality? That's just disgusting. ";
			"Yuck! You're into bestiality? That's just disgusting. ";
		}
	}
	
	dobjFor(GiveTo) {
		check() {
			"The frog looks at you with such love that it would be impossible for you to give
			it away. ";
			exit;
		}
	}
;

	+ Decoration 'big huge watery (frog) eyes' 'frog eyes'
		"It stares at you pleadingly with its huge watery eyes. The poor frog is so cute! "
		isPlural = true
	;
	+ Decoration 'flat broken (frog) legs' 'frog legs'
		"They're squashed flat. Clearly a careless or cruel motorist ran over this poor thing while
		the frog was attempting to cross the road. "
		isPlural = true
	;

	+ DefaultGiveShowTopic, ShuffledEventList [
		'The frog looks at you quizzically. '
		]
	;
	+ DefaultAnyTopic, ShuffledEventList [
		'The frog responds enthusiastically, <q>RIBBIT!</q> '
		]
	;

	+ frogSeesHole : ConvAgendaItem
		isReady = ( inherited() && (frog.isIn(froggerExitRowB) || frog.isIn(froggerExitRowC) || frog.isIn(froggerExitRowD))
			)
		invokeItem() {
			callWithSenseContext(frog,sight,{:
				"The frog's eyes bulge as it looks pleadingly at the hole in the cliff. "
				});
			callWithSenseContext(frog,sight,{:
				"Plaintively it cries, <q>RIBBIT! RIBBIT! RIBBIT!</q> "
				});
		
//			isDone = true;
		}
		
		initiallyActive = true
		isDone = nil
	;

/*
deadFrog : Thing 'frog carcass' 'frog carcass'
	@froggerRoadway3d
	"Ewww! This is the remains of a frog which apparently met its end underneath the tire
	of one of the cars on the road. No maggots are in evidence, so apparently it was run
	over fairly recently. The eyes are bulged out in a comical way, so being run over
	must not be all that bad. "
	initialDesc = "A frog carcass is smooshed in the road here. "
	
	dobjFor(Kiss) {
		verify() {}
		check() {}
		action() {
			"Yuck! You're into both necrophilia AND bestiality? That's just disgusting. ";
		}
	}
;
*/

